Tp::Service::ChannelAdaptor Class Reference

| Home · All Classes · All Namespaces · Modules · Functions · Files

Public Slots | Signals | Public Member Functions | List of all members
Tp::Service::ChannelAdaptor Class Reference
Channel service implementation

`#include <TelepathyQt/_gen/svc-channel.h>`

Inherits Tp::AbstractAdaptor.

## Public Slots
void | Close (const QDBusMessage &dbusMessage)
QString | GetChannelType (const QDBusMessage &dbusMessage)
uint | GetHandle (const QDBusMessage &dbusMessage, uint &targetHandle)
QStringList | GetInterfaces (const QDBusMessage &dbusMessage)

## Signals
void | Closed ()

## Public Member Functions
QString | ChannelType () const
QStringList | Interfaces () const
uint | TargetHandle () const
QString | TargetID () const
uint | TargetHandleType () const
bool | Requested () const
uint | InitiatorHandle () const
QString | InitiatorID () const
Public Member Functions inherited from Tp::AbstractAdaptor
| AbstractAdaptor (const QDBusConnection &connection, QObject *adaptee, QObject *parent)
| ~AbstractAdaptor ()
QDBusConnection | dbusConnection () const
QObject * | adaptee () const

## Detailed Description

Adaptor class providing a 1:1 mapping of the D-Bus interface "org.freedesktop.Telepathy.Channel".

## Member Function Documentation

QString Tp::Service::ChannelAdaptor::ChannelType | ( |  | ) | const

Return the value of the exported D-Bus object property `ChannelType` of type `QString`.

Adaptees should export this property as a Qt property named 'channelType' with type QString.

The channel's type. This cannot change once the channel has been created.

For compatibility between older connection managers and newer clients, if this is unavailable or is an empty string, clients MUST use the result of calling GetChannelType() .

The GetAll method lets clients retrieve all properties in one round-trip, which is desirable.

When requesting a channel, the request MUST specify a channel type, and the request MUST fail if the specified channel type cannot be supplied.

Common sense.

Returns
  The value of exported property `ChannelType`.

QStringList Tp::Service::ChannelAdaptor::Interfaces | ( |  | ) | const

Return the value of the exported D-Bus object property `Interfaces` of type `QStringList`.

Adaptees should export this property as a Qt property named 'interfaces' with type QStringList.

Extra interfaces provided by this channel. This SHOULD NOT include the channel type and the Channel interface itself, and cannot change once the channel has been created.

For compatibility between older connection managers and newer clients, if this is unavailable, or if this is an empty list and ChannelType is an empty string, clients MUST use the result of calling GetInterfaces() instead. If this is an empty list but ChannelType is non-empty, clients SHOULD NOT call GetInterfaces; this implies that connection managers that implement the ChannelType property MUST also implement the Interfaces property correctly.

The GetAll method lets clients retrieve all properties in one round-trip, which is desirable.

When requesting a channel with a particular value for this property, the request must fail without side-effects unless the connection manager expects to be able to provide a channel whose interfaces include at least the interfaces requested.

Returns
  The value of exported property `Interfaces`.

uint Tp::Service::ChannelAdaptor::TargetHandle | ( |  | ) | const

Return the value of the exported D-Bus object property `TargetHandle` of type `uint`.

Adaptees should export this property as a Qt property named 'targetHandle' with type uint.

The handle (a representation for the identifier) of the contact, chatroom, etc. with which this handle communicates. Its type is given by the TargetHandleType property.

This is fixed for the lifetime of the channel, so channels which could potentially be used to communicate with multiple contacts, and do not have an identity of their own (such as a Handle_Type_Room handle), must have TargetHandleType set to Handle_Type_None and TargetHandle set to 0.

Unlike in the telepathy-spec 0.16 API, there is no particular uniqueness guarantee - there can be many channels with the same (channel type, handle type, handle) tuple. This is necessary to support conversation threads in XMPP and SIP, for example.

If this is present in a channel request, it must be nonzero, TargetHandleType MUST be present and not Handle_Type_None, and TargetID MUST NOT be present. Properties from org.freedesktop.Telepathy.Channel.Interface.Addressing1 MUST NOT be present.

The channel that satisfies the request MUST either:

- have the specified TargetHandle property; or
- have TargetHandleType = Handle_Type_None, TargetHandle = 0, and be configured such that it could communicate with the specified handle in some other way (e.g. have the requested contact handle in its Group interface)

Returns
  The value of exported property `TargetHandle`.

QString Tp::Service::ChannelAdaptor::TargetID | ( |  | ) | const

Return the value of the exported D-Bus object property `TargetID` of type `QString`.

Adaptees should export this property as a Qt property named 'targetID' with type QString.

The string that would result from inspecting the TargetHandle property (i.e. the identifier in the IM protocol of the contact, room, etc. with which this channel communicates), or the empty string if the TargetHandle is 0.

The presence of this property avoids the following race condition:

- New channel C is signalled with target handle T
- Client calls ConnectionInterface::InspectHandles() (CONTACT, [T])
- Channel C closes, removing the last reference to handle T
- ConnectionInterface::InspectHandles() (CONTACT, [T]) returns an error

If this is present in a channel request, TargetHandleType MUST be present and not Handle_Type_None, and TargetHandle MUST NOT be present. Properties from org.freedesktop.Telepathy.Channel.Interface.Addressing1 MUST NOT be present.The request MUST fail with error InvalidHandle, without side-effects, if the requested TargetID would not be accepted by ConnectionInterface::RequestHandles() .

The returned channel must be related to the handle corresponding to the given identifier, in the same way as if TargetHandle had been part of the request instead.

Requesting channels with a string identifier saves a round-trip (the call to RequestHandles). It also allows the channel dispatcher to accept a channel request for an account that is not yet connected (and thus has no valid handles), bring the account online, and pass on the same parameters to the new connection's CreateChannel method.

Returns
  The value of exported property `TargetID`.

uint Tp::Service::ChannelAdaptor::TargetHandleType | ( |  | ) | const

Return the value of the exported D-Bus object property `TargetHandleType` of type `uint`.

Adaptees should export this property as a Qt property named 'targetHandleType' with type uint.

The type of TargetHandle .

If this is omitted from a channel request, connection managers SHOULD treat this as equivalent to Handle_Type_None.

If this is omitted or is Handle_Type_None, TargetHandle and TargetID MUST be omitted from the request.

Returns
  The value of exported property `TargetHandleType`.

bool Tp::Service::ChannelAdaptor::Requested | ( |  | ) | const

Return the value of the exported D-Bus object property `Requested` of type `bool`.

Adaptees should export this property as a Qt property named 'requested' with type bool.

True if this channel was created in response to a local request, such as a call to ConnectionInterface::RequestChannel() or ConnectionInterfaceRequestsInterface::CreateChannel() .

The idea of this property is to distinguish between "incoming" and "outgoing" channels, in a way that doesn't break down when considering special cases like contact lists that are automatically created on connection to the server, or chatrooms that an IRC proxy/bouncer like irssi-proxy or bip was already in.

The reason we want to make that distinction is that UIs for things that the user explicitly requested should start up automatically, whereas for incoming messages and VoIP calls we should first ask the user whether they want to open the messaging UI or accept the call.

If the channel was not explicitly requested (even if it was created as a side-effect of a call to one of those functions, e.g. because joining a Tube in a MUC context on XMPP implies joining that MUC), then this property is false.

For compatibility with older connection managers, clients SHOULD assume that this property is true if they see a channel announced by the ConnectionInterface::NewChannel() signal with the suppress_handler parameter set to true.

In a correct connection manager, the only way to get such a channel is to request it.

Clients MAY additionally assume that this property is false if they see a channel announced by the NewChannel signal with the suppress_handler parameter set to false.

This is more controversial, since it's possible to get that parameter set to false by requesting a channel. However, there's no good reason to do so, and we've deprecated this practice.

In the particular case of the channel dispatcher, the only side-effect of wrongly thinking a channel is unrequested is likely to be that the user has to confirm that they want to use it, so it seems fairly harmless to assume in the channel dispatcher that channels with suppress_handler false are indeed unrequested.

It does not make sense for this property to be in channel requests—it will always be true for channels returned by CreateChannel, and callers of EnsureChannel cannot control whether an existing channel was originally requested locally—so it MUST NOT be accepted.

Returns
  The value of exported property `Requested`.

uint Tp::Service::ChannelAdaptor::InitiatorHandle | ( |  | ) | const

Return the value of the exported D-Bus object property `InitiatorHandle` of type `uint`.

Adaptees should export this property as a Qt property named 'initiatorHandle' with type uint.

The contact who initiated the channel; for instance, the contact who invited the local user to a chatroom, or the contact who initiated a call.

This does not necessarily represent the contact who created the underlying protocol-level construct. For instance, if Rob creates a chatroom, Will joins that chatroom, and Will invites Simon to join it, then Simon will see Will as the InitiatorHandle of the channel representing the chatroom.

The room creator is generally a less useful piece of information than the inviter, is less likely to be available at invitation time (i.e. can't necessarily be an immutable property), and is less likely to be available at all. The creator of a chatroom is not currently available via Telepathy; if added in future, it is likely to be made available as a property on the Chatroom interface (bug 23151).

For channels requested by the local user, this MUST be the value of ConnectionInterface::SelfHandle at the time the channel was created (i.e. not a channel-specific handle).

On some protocols, the SelfHandle may change (as signalled by ConnectionInterface::SelfContactChanged() ), but this property is immutable. Hence, locally-requested channels' InitiatorHandle and InitiatorID may not match the current SelfHandle; Requested can be used to determine whether the channel was created locally.

For channels requested by a remote user, this MUST be their handle. If unavailable or not applicable, this MUST be 0 (for instance, contact lists are not really initiated by anyone in particular, and it's easy to imagine a protocol where chatroom invitations can be anonymous).

For channels with the ChannelInterfaceGroupInterface interface, this SHOULD be the same contact who is signalled as the "Actor" causing the self-handle to be placed in the local-pending set.

This SHOULD NOT be a channel-specific handle, if possible.

It does not make sense for this property to be in channel requests - the initiator will always be the local user - so it MUST NOT be accepted.

Returns
  The value of exported property `InitiatorHandle`.

QString Tp::Service::ChannelAdaptor::InitiatorID | ( |  | ) | const

Return the value of the exported D-Bus object property `InitiatorID` of type `QString`.

Adaptees should export this property as a Qt property named 'initiatorID' with type QString.

The string that would result from inspecting the InitiatorHandle property (i.e. the initiator's identifier in the IM protocol).

The presence of this property avoids the following race condition:

- New StreamedMedia channel C is signalled with initiator handle I
- Client calls ConnectionInterface::InspectHandles() (CONTACT, [I])
- Channel C closes, removing the last reference to handle I
- ConnectionInterface::InspectHandles() (CONTACT, [I]) returns an error
- Client can indicate that a call was missed, but not who called!

It does not make sense for this property to be in channel requests - the initiator will always be the local user - so it MUST NOT be accepted.

Returns
  The value of exported property `InitiatorID`.

void Tp::Service::ChannelAdaptor::Close | ( | const QDBusMessage & | dbusMessage | ) |
| slot

Begins a call to the exported D-Bus method `Close` on this object.

Adaptees should export this method as a Qt slot with the following signature: void close(const Tp::Service::ChannelAdaptor::CloseContextPtr &context);

Implementations should call MethodInvocationContext::setFinished (or setFinishedWithError accordingly) on the received context object once the method has finished processing.

Request that the channel be closed. This is not the case until the Closed signal has been emitted, and depending on the connection manager this may simply remove you from the channel on the server, rather than causing it to stop existing entirely. Some channels such as contact list channels may not be closed.

QString Tp::Service::ChannelAdaptor::GetChannelType | ( | const QDBusMessage & | dbusMessage | ) |
| slot

Begins a call to the exported D-Bus method `GetChannelType` on this object.

Adaptees should export this method as a Qt slot with the following signature: void getChannelType(const Tp::Service::ChannelAdaptor::GetChannelTypeContextPtr &context);

Implementations should call MethodInvocationContext::setFinished (or setFinishedWithError accordingly) on the received context object once the method has finished processing.

Returns the interface name for the type of this channel. Clients SHOULD use the ChannelType property instead, falling back to this method only if necessary. The GetAll method lets clients retrieve all properties in one round-trip.

Returns

      The interface name

uint Tp::Service::ChannelAdaptor::GetHandle | ( | const QDBusMessage & | dbusMessage,
|  | uint & | targetHandle
| ) |  |
| slot

Begins a call to the exported D-Bus method `GetHandle` on this object.

Adaptees should export this method as a Qt slot with the following signature: void getHandle(const Tp::Service::ChannelAdaptor::GetHandleContextPtr &context);

Implementations should call MethodInvocationContext::setFinished (or setFinishedWithError accordingly) on the received context object once the method has finished processing.

Returns the handle type and number if this channel represents a communication with a particular contact, room or server-stored list, or zero if it is transient and defined only by its contents. Clients SHOULD use the TargetHandle and TargetHandleType properties instead, falling back to this method only if necessary. The GetAll method lets clients retrieve all properties in one round-trip.

Parameters

  targetHandle | Output parameter
      The same as TargetHandle.

Returns

      The same as TargetHandleType.

QStringList Tp::Service::ChannelAdaptor::GetInterfaces | ( | const QDBusMessage & | dbusMessage | ) |
| slot

Begins a call to the exported D-Bus method `GetInterfaces` on this object.

Adaptees should export this method as a Qt slot with the following signature: void getInterfaces(const Tp::Service::ChannelAdaptor::GetInterfacesContextPtr &context);

Implementations should call MethodInvocationContext::setFinished (or setFinishedWithError accordingly) on the received context object once the method has finished processing.

Get the optional interfaces implemented by the channel. Clients SHOULD use the Interfaces property instead, falling back to this method only if necessary. The GetAll method lets clients retrieve all properties in one round-trip.

Returns

      An array of the D-Bus interface names

void Tp::Service::ChannelAdaptor::Closed | ( |  | ) |
| signal

Represents the exported D-Bus signal `Closed` on this object.

Adaptees should export this signal as a Qt signal with the following signature: void closed();

The adaptee signal will be automatically relayed as a D-Bus signal once emitted.